//******************************************************************************
// File Name            :  sw_if.v
//------------------------------------------------------------------------------
// Function             :  sw_if
//                        
//------------------------------------------------------------------------------
// Designer             : yokomizo@himwari_co 
//------------------------------------------------------------------------------
// History
// -.-- 2016/10/14
//******************************************************************************
module sw_if(
  clk_100m,
  rst,
  sw,
  sw_o
);

  input clk_100m;
  input rst;
  input [4:0]sw;
  output [4:0]sw_o;
  reg sw_d1;
  reg sw_d2;
  reg sw_d3;
  reg [19:0]cnt_base;
  wire sw_en;

always @ (posedge clk_100m )
  if(rst==1)
    cnt_base <= 20'd0;
  else
    cnt_base <= cnt_base + 20'h1;
    
assign sw_en =(cnt_base==20'hfffff)?1'b1:1'b0;
  
sw_if_1bit sw_if_1bit_0 (
  .clk_100m(clk_100m),
  .rst(rst),
  .sw(sw[0]),
  .sw_o(sw_o[0]),
  .sw_en(sw_en)
);  
      
sw_if_1bit sw_if_1bit_1 (
  .clk_100m(clk_100m),
  .rst(rst),
  .sw(sw[1]),
  .sw_o(sw_o[1]),
  .sw_en(sw_en)
);  

sw_if_1bit sw_if_1bit_2 (
  .clk_100m(clk_100m),
  .rst(rst),
  .sw(sw[2]),
  .sw_o(sw_o[2]),
  .sw_en(sw_en)
);  
sw_if_1bit sw_if_1bit_3 (
  .clk_100m(clk_100m),
  .rst(rst),
  .sw(sw[3]),
  .sw_o(sw_o[3]),
  .sw_en(sw_en)
);  
  sw_if_1bit sw_if_1bit_4 (
    .clk_100m(clk_100m),
    .rst(rst),
    .sw(sw[4]),
    .sw_o(sw_o[4]),
    .sw_en(sw_en)
  );  

        
endmodule








