//******************************************************************************
// File Name            :  sw_if_1bit.v
//------------------------------------------------------------------------------
// Function             :  sw_if
//                        
//------------------------------------------------------------------------------
// Designer             : yokomizo@himwari_co 
//------------------------------------------------------------------------------
// History
// -.-- 2016/10/14
//******************************************************************************
module sw_if_1bit(
  clk_100m,
  rst,
  sw,
  sw_o,
  sw_en
);

  input clk_100m;
  input rst;
  input sw;
  output sw_o;
  input sw_en;

  reg sw_o;
  reg sw_d1;
  reg sw_d2;
  reg sw_d3;

always @ (posedge clk_100m )
  if(rst==1)begin
    sw_d1 <= 1'b0;
    sw_d2 <= 1'b0;
    sw_d3 <= 1'b0;
  end
  else 
    if (sw_en==1'b1)
      begin
        sw_d1 <= sw;
        sw_d2 <= sw_d1;
        sw_d3 <= sw_d2;
      end
	else
      begin
        sw_d1 <= sw_d1;
        sw_d2 <= sw_d2;
        sw_d3 <= sw_d3;
      end
     
always @ (posedge clk_100m )
  if(rst==1)
    sw_o <= 1'b0;
  else
    if ((sw_en==1'b1)&&(sw_d1==1'b1)&&(sw_d2==1'b0)&&(sw_d3==1'b0)) 
      sw_o <= 1'b1;  
    else
      sw_o <= 1'b0;
	  
endmodule








